
function [out, ind] = resample(input, score, Ns)
%%Resample a set of particles
%input: particle states
%score: particle scores
%Ns: number of particles
%-------------------%
%out: resampled particle set
%ind: original particle index

c = zeros(1,Ns);
c(1) = score(1);
for i = 2:Ns+1
    c(i) = c(i - 1) + score(i);
end

l = 1;
u =  zeros(1,Ns);
u(1) = rand()/Ns;
for ii = 1:Ns
    u(ii) = u(1)+(ii-1)/Ns;
    while u(ii) > c(l)
        l = l+1;
    end
    out(ii) = input(l);
    ind(ii) = l;
end
